﻿using System.Collections.Generic;
using System.Linq;
using UnityEngine;

public class DabMod : Mod
{
    public static bool isDabbing;

    public static List<Network_Player> dabbers = new List<Network_Player>();

    public void Start()
    {
        Debug.Log("Mod DabMod has been loaded!");
    }

    public static void ToggleDab(Network_Player player, bool IsDabbing)
    {
        if (IsDabbing)
        {
            if (dabbers.Contains(player)) { return; } else { dabbers.Add(player); }
        }
        else
        {
            if (dabbers.Contains(player)) { dabbers.Remove(player); }
        }
    }

    [ConsoleCommand(name: "dab", docs: "Makes you dab!")]
    public static void dab()
    {
        Network_Player player = RAPI.GetLocalPlayer();
        bool isDabbing = dabbers.Contains(player);
        ToggleDab(player, !isDabbing);
        MessageHandler.SendMessage(new Message_DabMod_Dab((Messages)MessageHandler.NetworkMessages.DabMod_Dab, player.steamID, !isDabbing));
    }

    public void Update()
    {
        MessageHandler.ReadP2P_Channel_DabMod();
    }

    public void LateUpdate()
    {
        dabbers.ForEach((player) =>
        {
            player.transform.FindChildRecursivly("ORG-upper_arm_L").localRotation = Quaternion.Euler(80, 50, 40);
            player.transform.FindChildRecursivly("ORG-forearm_L").localRotation = Quaternion.Euler(0, 0, 0);
            player.transform.FindChildRecursivly("ORG-hand_L").localRotation = Quaternion.Euler(90, 0, 0);
            player.transform.FindChildRecursivly("ORG-hand_R").localRotation = Quaternion.Euler(270, 0, 0);

            if (player.IsLocalPlayer && player.currentModel.thirdPersonSettings.ThirdPersonState == false)
            {
                player.transform.FindChildRecursivly("ORG-upper_arm_R").localRotation = Quaternion.Euler(45, 0, 240);
                player.transform.FindChildRecursivly("ORG-forearm_R").localRotation = Quaternion.Euler(20, -30, -75);
            }
            else
            {
                player.transform.FindChildRecursivly("ORG-forearm_R").localRotation = Quaternion.Euler(20, 30, -90);
                player.transform.FindChildRecursivly("ORG-upper_arm_R").localRotation = Quaternion.Euler(0, 0, 240);
                player.transform.FindChildRecursivly("ORG-neck").localRotation = Quaternion.Euler(-45, 45, 0);
            }
        });
    }

    public void OnGUI()
    {
        if (dabbers.Contains(RAPI.GetLocalPlayer()))
        {
            GUIStyle style = new GUIStyle();
            style.fontSize = 25;
            style.fontStyle = FontStyle.Bold;
            style.normal.textColor = Color.white;
            style.alignment = TextAnchor.MiddleCenter;
            DrawOutline(new Rect(0, 10, Screen.width, 100), "You are dabbing!", 1, style);
            GUI.Label(new Rect(0, 10, Screen.width, 100), "You are dabbing!", style);
        }
    }

    void DrawOutline(Rect r, string t, int strength, GUIStyle style)
    {
        GUI.color = new Color(0, 0, 0, 1);
        int i;
        for (i = -strength; i <= strength; i++)
        {
            GUI.Label(new Rect(r.x - strength, r.y + i, r.width, r.height), t, style);
            GUI.Label(new Rect(r.x + strength, r.y + i, r.width, r.height), t, style);
        }
        for (i = -strength + 1; i <= strength - 1; i++)
        {
            GUI.Label(new Rect(r.x + i, r.y - strength, r.width, r.height), t, style);
            GUI.Label(new Rect(r.x + i, r.y + strength, r.width, r.height), t, style);
        }
        GUI.color = new Color(1, 1, 1, 1);
    }

    public void OnModUnload()
    {
        Debug.Log("Mod DabMod has been unloaded!");
    }
}